//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private AlexrVolumeProfileVPOCwithDelta[] cacheAlexrVolumeProfileVPOCwithDelta = null;

        private static AlexrVolumeProfileVPOCwithDelta checkAlexrVolumeProfileVPOCwithDelta = new AlexrVolumeProfileVPOCwithDelta();

        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        public AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            return AlexrVolumeProfileVPOCwithDelta(Input, alertSound, deltaCalculationType, drawTail, filterDelta, filterVolume, onlyBothPOC, pathSoundAlert, showLastBar);
        }

        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        public AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(Data.IDataSeries input, bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            if (cacheAlexrVolumeProfileVPOCwithDelta != null)
                for (int idx = 0; idx < cacheAlexrVolumeProfileVPOCwithDelta.Length; idx++)
                    if (cacheAlexrVolumeProfileVPOCwithDelta[idx].AlertSound == alertSound && cacheAlexrVolumeProfileVPOCwithDelta[idx].DeltaCalculationType == deltaCalculationType && cacheAlexrVolumeProfileVPOCwithDelta[idx].DrawTail == drawTail && cacheAlexrVolumeProfileVPOCwithDelta[idx].FilterDelta == filterDelta && cacheAlexrVolumeProfileVPOCwithDelta[idx].FilterVolume == filterVolume && cacheAlexrVolumeProfileVPOCwithDelta[idx].OnlyBothPOC == onlyBothPOC && cacheAlexrVolumeProfileVPOCwithDelta[idx].PathSoundAlert == pathSoundAlert && cacheAlexrVolumeProfileVPOCwithDelta[idx].ShowLastBar == showLastBar && cacheAlexrVolumeProfileVPOCwithDelta[idx].EqualsInput(input))
                        return cacheAlexrVolumeProfileVPOCwithDelta[idx];

            lock (checkAlexrVolumeProfileVPOCwithDelta)
            {
                checkAlexrVolumeProfileVPOCwithDelta.AlertSound = alertSound;
                alertSound = checkAlexrVolumeProfileVPOCwithDelta.AlertSound;
                checkAlexrVolumeProfileVPOCwithDelta.DeltaCalculationType = deltaCalculationType;
                deltaCalculationType = checkAlexrVolumeProfileVPOCwithDelta.DeltaCalculationType;
                checkAlexrVolumeProfileVPOCwithDelta.DrawTail = drawTail;
                drawTail = checkAlexrVolumeProfileVPOCwithDelta.DrawTail;
                checkAlexrVolumeProfileVPOCwithDelta.FilterDelta = filterDelta;
                filterDelta = checkAlexrVolumeProfileVPOCwithDelta.FilterDelta;
                checkAlexrVolumeProfileVPOCwithDelta.FilterVolume = filterVolume;
                filterVolume = checkAlexrVolumeProfileVPOCwithDelta.FilterVolume;
                checkAlexrVolumeProfileVPOCwithDelta.OnlyBothPOC = onlyBothPOC;
                onlyBothPOC = checkAlexrVolumeProfileVPOCwithDelta.OnlyBothPOC;
                checkAlexrVolumeProfileVPOCwithDelta.PathSoundAlert = pathSoundAlert;
                pathSoundAlert = checkAlexrVolumeProfileVPOCwithDelta.PathSoundAlert;
                checkAlexrVolumeProfileVPOCwithDelta.ShowLastBar = showLastBar;
                showLastBar = checkAlexrVolumeProfileVPOCwithDelta.ShowLastBar;

                if (cacheAlexrVolumeProfileVPOCwithDelta != null)
                    for (int idx = 0; idx < cacheAlexrVolumeProfileVPOCwithDelta.Length; idx++)
                        if (cacheAlexrVolumeProfileVPOCwithDelta[idx].AlertSound == alertSound && cacheAlexrVolumeProfileVPOCwithDelta[idx].DeltaCalculationType == deltaCalculationType && cacheAlexrVolumeProfileVPOCwithDelta[idx].DrawTail == drawTail && cacheAlexrVolumeProfileVPOCwithDelta[idx].FilterDelta == filterDelta && cacheAlexrVolumeProfileVPOCwithDelta[idx].FilterVolume == filterVolume && cacheAlexrVolumeProfileVPOCwithDelta[idx].OnlyBothPOC == onlyBothPOC && cacheAlexrVolumeProfileVPOCwithDelta[idx].PathSoundAlert == pathSoundAlert && cacheAlexrVolumeProfileVPOCwithDelta[idx].ShowLastBar == showLastBar && cacheAlexrVolumeProfileVPOCwithDelta[idx].EqualsInput(input))
                            return cacheAlexrVolumeProfileVPOCwithDelta[idx];

                AlexrVolumeProfileVPOCwithDelta indicator = new AlexrVolumeProfileVPOCwithDelta();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AlertSound = alertSound;
                indicator.DeltaCalculationType = deltaCalculationType;
                indicator.DrawTail = drawTail;
                indicator.FilterDelta = filterDelta;
                indicator.FilterVolume = filterVolume;
                indicator.OnlyBothPOC = onlyBothPOC;
                indicator.PathSoundAlert = pathSoundAlert;
                indicator.ShowLastBar = showLastBar;
                Indicators.Add(indicator);
                indicator.SetUp();

                AlexrVolumeProfileVPOCwithDelta[] tmp = new AlexrVolumeProfileVPOCwithDelta[cacheAlexrVolumeProfileVPOCwithDelta == null ? 1 : cacheAlexrVolumeProfileVPOCwithDelta.Length + 1];
                if (cacheAlexrVolumeProfileVPOCwithDelta != null)
                    cacheAlexrVolumeProfileVPOCwithDelta.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheAlexrVolumeProfileVPOCwithDelta = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            return _indicator.AlexrVolumeProfileVPOCwithDelta(Input, alertSound, deltaCalculationType, drawTail, filterDelta, filterVolume, onlyBothPOC, pathSoundAlert, showLastBar);
        }

        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        public Indicator.AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(Data.IDataSeries input, bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            return _indicator.AlexrVolumeProfileVPOCwithDelta(input, alertSound, deltaCalculationType, drawTail, filterDelta, filterVolume, onlyBothPOC, pathSoundAlert, showLastBar);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            return _indicator.AlexrVolumeProfileVPOCwithDelta(Input, alertSound, deltaCalculationType, drawTail, filterDelta, filterVolume, onlyBothPOC, pathSoundAlert, showLastBar);
        }

        /// <summary>
        /// VPOC with Delta v 2.3.4. Alex_r(2015)
        /// </summary>
        /// <returns></returns>
        public Indicator.AlexrVolumeProfileVPOCwithDelta AlexrVolumeProfileVPOCwithDelta(Data.IDataSeries input, bool alertSound, AlexDeltaCalculationType deltaCalculationType, bool drawTail, int filterDelta, int filterVolume, bool onlyBothPOC, string pathSoundAlert, bool showLastBar)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.AlexrVolumeProfileVPOCwithDelta(input, alertSound, deltaCalculationType, drawTail, filterDelta, filterVolume, onlyBothPOC, pathSoundAlert, showLastBar);
        }
    }
}
#endregion
